#include "component_collider.h"

/* DEPENDENCIES: Physics */

/* Sets collider component info. */
void
component_collider_init(ComponentCollider* self, vec2 offset, vec2 size)
{
	glm_vec2_copy(size, self->size);
	glm_vec2_copy(offset, self->offset);
	vector_init(&self->collisions, sizeof(u32);
}

/* Ticks collider component. */
void
component_collider_tick(ComponentCollider* self, ECS* ecs)
{
	ComponentPhysics* physics;
	vec4 rectangle;

	vector_clear(&self->collisions);

	ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, self->id);

	rectangle[0] = physics->position[0] + self->offset[0];
	rectangle[1] = physics->position[1] + self->offset[1];
	rectangle[2] = rectangle[0] + self->size[0];
	rectangle[3] = rectangle[1] + self->size[1];

	for (s32 i = 0; i < ecs->lists[ECS_COMPONENT_COLLIDER]; i++)
	{
		


	}
}
