#pragma once

#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "../component_physics.h"

typedef struct ComponentReturn
{
	u32 id;
	f32 speed;
	f32 velocityMax;
	u32 lifetime;
	u32 senderID;
} ComponentReturn;

void component_return_init(ComponentReturn* self, f32 speed, f32 velocityMax, u32 lifetime, u32 senderID);
void component_return_tick(ComponentReturn* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_RETURN_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL, 
			(ECSFunction)component_return_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_RETURN,
	.size = sizeof(ComponentReturn)
};


