#include "component_shoot.h"

/* DEPENDENCIES: Physics */

/* Sets shoot component info. */
void
component_shoot_init
(
	ComponentShoot* self, 
	ProjectileInit projectileInit, 
	f32 speed, 
	f32 offset
)
{
	self->projectileInit = projectileInit;
	self->speed = speed;
	self->offset = offset;
}

/* Ticks shoot component. */
void
component_shoot_tick(ComponentShoot* self, ECS* ecs)
{
	if (self->isFire)
	{
		ComponentPhysics* physics;
		ComponentPhysics* projectilePhysics;
		u32 projectile;
		vec3 position;

		projectile = ecs_entity_add(ecs);

		physics = ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, self->id);

		position[0] += -cos(physics->angle) * self->offset;
		position[1] += -sin(physics->angle) * self->offset;

		glm_vec3_copy(physics->position, position);

		self->projectileInit(ecs, projectile, position, self->id);

		projectilePhysics = ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, projectile);
		
		projectilePhysics->angle = physics->angle;

		projectilePhysics->velocity[0] = -cos(projectilePhysics->angle) * self->speed;
		projectilePhysics->velocity[1] = -sin(projectilePhysics->angle) * self->speed;

		self->isFire = false;
	}
}
