#include "component_control_aim.h"

/* DEPENDENCIES: Physics */

/* Ticks control_aim component. Sets facing angle to that of the mouse. */
void
component_control_aim_tick(ComponentControlAim* self, ECS* ecs)
{
	ComponentPhysics* physics;
	f32 angle;
	vec2 position;

	mouse_world_position_get(&ecs->game->input.mouse, &ecs->game->renderer, position);

	physics = ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, self->id);

	angle = ATAN(position[0], physics->position[0], position[1], physics->position[1]);

	printf("MOUSE POSITION: %f %f\n", position[0], position[1]);
	printf("PHYSICS POSITION: %f %f\n", physics->position[0], physics->position[1]);
	printf("ANGLE: %f\n", angle);

	physics->angle = angle;
}
