#include "component_control_shoot.h"

/* DEPENDENCIES: Shoot, Ammo */

/* Initializes control shoot component. */
void
component_control_shoot_init(ComponentControlShoot* self, u32 delay)
{
	self->delayMax = delay;
	self->delay = self->delayMax;
}

/* Ticks control_shoot component. */
void
component_control_shoot_tick(ComponentControlShoot* self, ECS* ecs)
{
	ComponentAmmo* ammo;

	if (self->delay > 0)
	{
		self->delay--;
		return;
	}

	ammo = ecs_component_get(ecs, ECS_COMPONENT_AMMO, self->id);

	if (input_held(&ecs->game->input, INPUT_SHOOT) && !ammo->isOut)
	{
		ComponentShoot* shoot;

		shoot = ecs_component_get(ecs, ECS_COMPONENT_SHOOT, self->id);

		shoot->isFire = true;

		self->delay = self->delayMax;

		ammo->value--;
	}
}
