#include "entity_player.h"

/* Initializes a player entity. */
void
entity_player_init(ECS* ecs, u32 id, vec3 position)
{
	ComponentAmmo* ammo;
	ComponentControlMove* controlMove;
	ComponentControlShoot* controlShoot;
	ComponentGameObject* gameObject;
	ComponentHealth* health;
	ComponentShoot* shoot;

	ammo = ecs_component_add(ecs, ECS_COMPONENT_AMMO, id);
	controlMove = ecs_component_add(ecs, ECS_COMPONENT_CONTROL_MOVE, id);
	controlShoot = ecs_component_add(ecs, ECS_COMPONENT_CONTROL_SHOOT, id);
	gameObject = ecs_component_add(ecs, ECS_COMPONENT_GAME_OBJECT, id);
	health = ecs_component_add(ecs, ECS_COMPONENT_HEALTH, id);
	shoot = ecs_component_add(ecs, ECS_COMPONENT_SHOOT, id);
	
	ecs_component_add(ecs, ECS_COMPONENT_CONTROL_AIM, id);

	component_game_object_init
	(
		gameObject,
		ecs,
		ecs->game->resources.textures[TEXTURE_PLAYER],
		SHADER_TEXTURE_QUAD,
		ORIGIN_CENTER,
		(f32*)PLAYER_SIZE,
		position,
		(f32*)COLOR_OPAQUE,
		PLAYER_FRICTION,
		PLAYER_VELOCITY_MAX
	);

	component_control_move_init(controlMove, PLAYER_SPEED);

	component_shoot_init
	(
		shoot,
		(ProjectileInit)entity_snake_init,
		PLAYER_SHOOT_SPEED,
		PLAYER_SHOOT_OFFSET
	);

	component_control_shoot_init(controlShoot, PLAYER_CONTROL_SHOOT_DELAY);

	component_health_init(health, PLAYER_HEALTH_MAX);
	component_ammo_init(ammo, PLAYER_AMMO_MAX);
}
